net.minecraft.client.renderer

## Class RenderEngine

- java.lang.Object
- - net.minecraft.client.renderer.RenderEngine

-     public class RenderEngine
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Logger` | `log`
    `TextureMap` | `textureMapBlocks`
    `TextureMap` | `textureMapItems`
    `TexturePackList` | `texturePack` Texture pack

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RenderEngine(TexturePackList par1TexturePackList, GameSettings par2GameSettings)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `allocateAndSetupTexture(BufferedImage par1BufferedImage)` Copy the supplied image onto a newly-allocated OpenGL texture, returning the allocated texture name
    `void` | `bindTexture(String par1Str)`
    `void` | `createTextureFromBytes(int[] par1ArrayOfInteger, int par2, int par3, int par4)`
    `void` | `deleteTexture(int par1)` Deletes a single GL texture
    `Icon` | `getMissingIcon(int par1)`
    `int` | `getTexture(String par1Str)`
    `int[]` | `getTextureContents(String par1Str)`
    `int` | `getTextureForDownloadableImage(String par1Str, String par2Str)` Takes a URL of a downloadable image and the name of the local image to be used as a fallback.
    `boolean` | `hasImageData(String par1Str)` Checks if urlToImageDataMap has image data for the given key
    `ThreadDownloadImageData` | `obtainImageData(String par1Str, IImageBuffer par2IImageBuffer)` Return a ThreadDownloadImageData instance for the given URL.
    `void` | `refreshTextureMaps()`
    `void` | `refreshTextures()` Call setupTexture on all currently-loaded textures again to account for changes in rendering options
    `void` | `releaseImageData(String par1Str)` Decrements the reference count for a given URL, deleting the image data if the reference count hits 0
    `void` | `resetBoundTexture()`
    `void` | `setupTexture(BufferedImage par1BufferedImage, int par2)` Copy the supplied image onto the specified OpenGL texture
    `void` | `setupTextureExt(BufferedImage par1BufferedImage, int par2, boolean par3, boolean par4)`
    `void` | `updateDynamicTextures()`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### texturePack

          public TexturePackList texturePack

      Texture pack

    - #### textureMapBlocks

          public final TextureMap textureMapBlocks

    - #### textureMapItems

          public final TextureMap textureMapItems

    - #### log

          public static Logger log

  - ### Constructor Detail

    - #### RenderEngine

          public RenderEngine(TexturePackList par1TexturePackList,
                      GameSettings par2GameSettings)

  - ### Method Detail

    - #### getTextureContents

          public int[] getTextureContents(String par1Str)

    - #### bindTexture

          public void bindTexture(String par1Str)

    - #### resetBoundTexture

          public void resetBoundTexture()

    - #### getTexture

          public int getTexture(String par1Str)

    - #### allocateAndSetupTexture

          public int allocateAndSetupTexture(BufferedImage par1BufferedImage)

      Copy the supplied image onto a newly-allocated OpenGL texture, returning the allocated texture name

    - #### setupTexture

          public void setupTexture(BufferedImage par1BufferedImage,
                          int par2)

      Copy the supplied image onto the specified OpenGL texture

    - #### setupTextureExt

          public void setupTextureExt(BufferedImage par1BufferedImage,
                             int par2,
                             boolean par3,
                             boolean par4)

    - #### createTextureFromBytes

          public void createTextureFromBytes(int[] par1ArrayOfInteger,
                                    int par2,
                                    int par3,
                                    int par4)

    - #### deleteTexture

          public void deleteTexture(int par1)

      Deletes a single GL texture

    - #### getTextureForDownloadableImage

          public int getTextureForDownloadableImage(String par1Str,
                                           String par2Str)

      Takes a URL of a downloadable image and the name of the local image to be used as a fallback. If the image has been downloaded, returns the GL texture of the downloaded image, otherwise returns the GL texture of the fallback image.

    - #### hasImageData

          public boolean hasImageData(String par1Str)

      Checks if urlToImageDataMap has image data for the given key

    - #### obtainImageData

          public ThreadDownloadImageData obtainImageData(String par1Str,
                                                IImageBuffer par2IImageBuffer)

      Return a ThreadDownloadImageData instance for the given URL. If it does not already exist, it is created and uses the passed ImageBuffer. If it does, its reference count is incremented.

    - #### releaseImageData

          public void releaseImageData(String par1Str)

      Decrements the reference count for a given URL, deleting the image data if the reference count hits 0

    - #### updateDynamicTextures

          public void updateDynamicTextures()

    - #### refreshTextures

          public void refreshTextures()

      Call setupTexture on all currently-loaded textures again to account for changes in rendering options

    - #### refreshTextureMaps

          public void refreshTextureMaps()

    - #### getMissingIcon

          public Icon getMissingIcon(int par1)